/* Db.c generated by valac 0.18.0, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2011-2012 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;


extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar** app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 16
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
DbVerifyResult db_upgrade_database (gint input_version);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg);
void tag_table_upgrade_for_htags (void);
void gsettings_configuration_engine_run_gsettings_migrator (void);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);


void db_preconfigure (GFile* db_file) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 14 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	g_return_if_fail ((db_file == NULL) || G_IS_FILE (db_file));
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp1_ = db_file;
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp1_ != NULL) {
#line 96 "Db.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp2_ = db_file;
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp0_ = _tmp3_;
#line 107 "Db.c"
	} else {
		gchar* _tmp4_;
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp4_ = g_strdup (DB_IN_MEMORY_NAME);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp0_ = _tmp4_;
#line 116 "Db.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp5_ = _tmp0_;
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_g_free0 (db_filename);
#line 15 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	db_filename = _tmp6_;
#line 14 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 128 "Db.c"
}


void db_init (GError** error) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 19 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp0_ = db_filename;
#line 19 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_vala_assert (_tmp0_ != NULL, "filename != null");
#line 21 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp1_ = db_filename;
#line 21 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	database_table_init (_tmp1_);
#line 143 "Db.c"
}


void db_terminate (void) {
#line 25 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	database_table_terminate ();
#line 150 "Db.c"
}


GType db_verify_result_get_type (void) {
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
		GType db_verify_result_type_id;
		db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}


DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version) {
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	DbVerifyResult result = 0;
	VersionTable* _tmp0_ = NULL;
	VersionTable* version_table;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_;
	gint _tmp7_;
#line 36 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 36 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version_table = _tmp0_;
#line 37 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp1_ = version_table;
#line 37 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 37 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 37 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 37 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 39 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp4_ = _vala_schema_version;
#line 39 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp4_ >= 0) {
#line 195 "Db.c"
		gint _tmp5_;
		const gchar* _tmp6_;
#line 40 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp5_ = _vala_schema_version;
#line 40 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp6_ = _vala_app_version;
#line 40 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _tmp5_, _tmp6_);
#line 204 "Db.c"
	}
#line 42 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp7_ = _vala_schema_version;
#line 42 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp7_ == (-1)) {
#line 210 "Db.c"
		VersionTable* _tmp8_;
		gchar* _tmp9_;
#line 44 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 46 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp8_ = version_table;
#line 46 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		version_table_set_version (_tmp8_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 47 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp9_ = g_strdup (RESOURCES_APP_VERSION);
#line 47 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 47 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_vala_app_version = _tmp9_;
#line 48 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 227 "Db.c"
	} else {
		gint _tmp10_;
#line 49 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp10_ = _vala_schema_version;
#line 49 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (_tmp10_ > DATABASE_TABLE_SCHEMA_VERSION) {
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			if (app_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				*app_version = _vala_app_version;
#line 242 "Db.c"
			} else {
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 246 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			if (schema_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 252 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 256 "Db.c"
		} else {
			gint _tmp11_;
#line 52 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			_tmp11_ = _vala_schema_version;
#line 52 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			if (_tmp11_ < DATABASE_TABLE_SCHEMA_VERSION) {
#line 263 "Db.c"
				gint _tmp12_;
				DbVerifyResult _tmp13_ = 0;
				DbVerifyResult _result_;
				DbVerifyResult _tmp14_;
#line 54 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				_tmp12_ = _vala_schema_version;
#line 54 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				_tmp13_ = db_upgrade_database (_tmp12_);
#line 54 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				_result_ = _tmp13_;
#line 55 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				_tmp14_ = _result_;
#line 55 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
				if (_tmp14_ != DB_VERIFY_RESULT_OK) {
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
					result = _result_;
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
					if (app_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
						*app_version = _vala_app_version;
#line 286 "Db.c"
					} else {
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 290 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
					if (schema_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 296 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
					return result;
#line 300 "Db.c"
				}
			}
		}
	}
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (app_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		*app_version = _vala_app_version;
#line 313 "Db.c"
	} else {
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 317 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (schema_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 323 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	return result;
#line 327 "Db.c"
}


DbVerifyResult db_upgrade_database (gint input_version) {
	DbVerifyResult result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint version;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp23_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gint _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	VersionTable* _tmp39_ = NULL;
	VersionTable* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
#line 63 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp0_ = input_version;
#line 63 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_vala_assert (_tmp0_ < DATABASE_TABLE_SCHEMA_VERSION, "input_version < DatabaseTable.SCHEMA_VERSION");
#line 65 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp1_ = input_version;
#line 65 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = _tmp1_;
#line 68 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp2_ = version;
#line 68 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp2_ == 1) {
#line 69 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
#line 69 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		return result;
#line 378 "Db.c"
	}
#line 71 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp3_ = version;
#line 71 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	g_message ("Db.vala:71: Upgrading database from schema version %d to %d", _tmp3_, DATABASE_TABLE_SCHEMA_VERSION);
#line 83 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp4_ = database_table_has_column ("PhotoTable", "flags");
#line 83 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp4_) {
#line 388 "Db.c"
		gboolean _tmp5_ = FALSE;
#line 84 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:84: upgrade_database: adding flags column to PhotoTable");
#line 85 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp5_ = database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0");
#line 85 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp5_) {
#line 86 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 86 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 400 "Db.c"
		}
	}
#line 89 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 3;
#line 100 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp6_ = database_table_has_column ("PhotoTable", "file_format");
#line 100 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp6_) {
#line 409 "Db.c"
		gboolean _tmp7_ = FALSE;
#line 101 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:101: upgrade_database: adding file_format column to PhotoTable");
#line 102 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp7_ = database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0");
#line 102 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp7_) {
#line 103 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 103 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 421 "Db.c"
		}
	}
#line 106 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 4;
#line 113 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp8_ = database_table_has_column ("PhotoTable", "title");
#line 113 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp8_) {
#line 430 "Db.c"
		gboolean _tmp9_ = FALSE;
#line 114 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:114: upgrade_database: adding title column to PhotoTable");
#line 115 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp9_ = database_table_add_column ("PhotoTable", "title", "TEXT");
#line 115 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp9_) {
#line 116 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 116 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 442 "Db.c"
		}
	}
#line 119 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 5;
#line 126 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp10_ = database_table_has_column ("PhotoTable", "backlinks");
#line 126 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp10_) {
#line 451 "Db.c"
		gboolean _tmp11_ = FALSE;
#line 127 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:127: upgrade_database: adding backlinks column to PhotoTable");
#line 128 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp11_ = database_table_add_column ("PhotoTable", "backlinks", "TEXT");
#line 128 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp11_) {
#line 129 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 129 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 463 "Db.c"
		}
	}
#line 132 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 6;
#line 146 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp12_ = database_table_has_column ("PhotoTable", "time_reimported");
#line 146 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp12_) {
#line 472 "Db.c"
		gboolean _tmp13_ = FALSE;
#line 147 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:147: upgrade_database: adding time_reimported column to PhotoT" \
"able");
#line 148 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp13_ = database_table_add_column ("PhotoTable", "time_reimported", "INTEGER");
#line 148 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp13_) {
#line 149 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 149 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 484 "Db.c"
		}
	}
#line 152 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp14_ = database_table_has_column ("PhotoTable", "editable_id");
#line 152 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp14_) {
#line 491 "Db.c"
		gboolean _tmp15_ = FALSE;
#line 153 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:153: upgrade_database: adding editable_id column to PhotoTable");
#line 154 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp15_ = database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1");
#line 154 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp15_) {
#line 155 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 155 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 503 "Db.c"
		}
	}
#line 158 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 7;
#line 170 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp16_ = database_table_has_column ("PhotoTable", "rating");
#line 170 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp16_) {
#line 512 "Db.c"
		gboolean _tmp17_ = FALSE;
#line 171 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:171: upgrade_database: adding rating column to PhotoTable");
#line 172 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp17_ = database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0");
#line 172 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp17_) {
#line 173 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 173 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 524 "Db.c"
		}
	}
#line 182 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp18_ = database_table_has_column ("PhotoTable", "metadata_dirty");
#line 182 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp18_) {
#line 531 "Db.c"
		gboolean _tmp19_ = FALSE;
#line 183 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:183: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
#line 184 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp19_ = database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1");
#line 184 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp19_) {
#line 185 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 185 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 543 "Db.c"
		}
	}
#line 188 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 9;
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp21_ = database_table_has_table ("VideoTable");
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp21_) {
#line 552 "Db.c"
		gboolean _tmp22_ = FALSE;
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp22_ = database_table_has_column ("VideoTable", "flags");
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp20_ = !_tmp22_;
#line 558 "Db.c"
	} else {
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp20_ = FALSE;
#line 562 "Db.c"
	}
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp23_ = _tmp20_;
#line 195 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp23_) {
#line 568 "Db.c"
		gboolean _tmp24_ = FALSE;
#line 196 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:196: upgrade_database: adding flags column to VideoTable");
#line 197 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp24_ = database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0");
#line 197 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp24_) {
#line 198 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 198 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 580 "Db.c"
		}
	}
#line 201 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 10;
#line 208 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp25_ = database_table_has_column ("EventTable", "primary_source_id");
#line 208 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp25_) {
#line 589 "Db.c"
		gboolean _tmp26_ = FALSE;
#line 209 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:209: upgrade_database: adding primary_source_id column to Even" \
"tTable");
#line 210 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp26_ = database_table_add_column ("EventTable", "primary_source_id", "INTEGER DEFAULT 0");
#line 210 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp26_) {
#line 211 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 211 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 601 "Db.c"
		}
	}
#line 214 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 11;
#line 221 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp27_ = database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable");
#line 221 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp27_) {
#line 223 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 223 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		return result;
#line 614 "Db.c"
	}
#line 226 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 12;
#line 233 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp28_ = database_table_has_column ("PhotoTable", "developer");
#line 233 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp28_) {
#line 622 "Db.c"
		gboolean _tmp29_ = FALSE;
#line 234 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:234: upgrade_database: adding developer column to PhotoTable");
#line 235 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp29_ = database_table_add_column ("PhotoTable", "developer", "TEXT");
#line 235 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp29_) {
#line 236 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 236 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 634 "Db.c"
		}
	}
#line 239 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp30_ = database_table_has_column ("PhotoTable", "develop_shotwell_id");
#line 239 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp30_) {
#line 641 "Db.c"
		gboolean _tmp31_ = FALSE;
#line 240 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:240: upgrade_database: adding develop_shotwell_id column to Ph" \
"otoTable");
#line 241 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp31_ = database_table_add_column ("PhotoTable", "develop_shotwell_id", "INTEGER DEFAULT -1");
#line 241 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp31_) {
#line 242 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 242 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 653 "Db.c"
		}
	}
#line 245 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp32_ = database_table_has_column ("PhotoTable", "develop_camera_id");
#line 245 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp32_) {
#line 660 "Db.c"
		gboolean _tmp33_ = FALSE;
#line 246 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:246: upgrade_database: adding develop_camera_id column to Phot" \
"oTable");
#line 247 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp33_ = database_table_add_column ("PhotoTable", "develop_camera_id", "INTEGER DEFAULT -1");
#line 247 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp33_) {
#line 248 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 248 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 672 "Db.c"
		}
	}
#line 251 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp34_ = database_table_has_column ("PhotoTable", "develop_embedded_id");
#line 251 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (!_tmp34_) {
#line 679 "Db.c"
		gboolean _tmp35_ = FALSE;
#line 252 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		g_message ("Db.vala:252: upgrade_database: adding develop_embedded_id column to Ph" \
"otoTable");
#line 253 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		_tmp35_ = database_table_add_column ("PhotoTable", "develop_embedded_id", "INTEGER DEFAULT -1");
#line 253 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		if (!_tmp35_) {
#line 254 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 254 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
			return result;
#line 691 "Db.c"
		}
	}
#line 257 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 13;
#line 264 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp36_ = input_version;
#line 264 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp36_ < 14) {
#line 265 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		tag_table_upgrade_for_htags ();
#line 702 "Db.c"
	}
#line 267 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 14;
#line 279 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 15;
#line 289 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp37_ = input_version;
#line 289 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	if (_tmp37_ < 16) {
#line 292 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
		gsettings_configuration_engine_run_gsettings_migrator ();
#line 714 "Db.c"
	}
#line 295 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version = 16;
#line 301 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp38_ = version;
#line 301 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_vala_assert (_tmp38_ == DATABASE_TABLE_SCHEMA_VERSION, "version == DatabaseTable.SCHEMA_VERSION");
#line 302 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp39_ = version_table_get_instance ();
#line 302 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp40_ = _tmp39_;
#line 302 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp41_ = version;
#line 302 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	version_table_update_version (_tmp40_, _tmp41_, RESOURCES_APP_VERSION);
#line 302 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_database_table_unref0 (_tmp40_);
#line 304 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	_tmp42_ = version;
#line 304 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	g_message ("Db.vala:304: Database upgrade to schema version %d successful", _tmp42_);
#line 306 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 306 "/builddir/build/BUILD/shotwell-0.13.1/src/db/Db.vala"
	return result;
#line 740 "Db.c"
}



